protocol TitleProvider {
    var title: String { get }
}

class Worker {
    class func doWork<Input>(input: Input) {
        print("do work")
        work(input: input)
    }
    
    class func work<Input>(input: Input) {
        print("work")
    }
}

class EnhancedWorker: Worker {
    override class func work<Input: TitleProvider>(input: Input) {
        super.work(input: input)
        
        print("overridden work")
        print("Title is \(input.title)")
    }
}

class UberWorker: EnhancedWorker {
    override class func work<Input: TitleProvider>(input: Input) {
        super.work(input: input)
        
        print("overridden uber work")
        print("Uber title is \(input.title)")
    }
}

class WorkData {
    
}

class ExtendedWorkData: WorkData, TitleProvider {
    let title = "Hardcoded Title"
}

let extendedData = ExtendedWorkData()

UberWorker.doWork(input: extendedData)
