protocol TitleProvider {
    var title: String { get }
}

class Worker {
    class func work<Input>(input: Input) {
        ()
    }
}

class EnhancedWorker: Worker {
    override class func work<Input: TitleProvider>(input: Input) {
        super.work(input: input)
        print("Title is \(input.title)")
    }
}

struct WorkData: TitleProvider {
    let title = "Hardcoded Title"
}

let data = WorkData()

let workerClass = Worker.self
let enhancedWorkerClass: Worker.Type = EnhancedWorker.self

enhancedWorkerClass.work(input: data)
